<!DOCTYPE html>
<html lang="zh-cn">

<head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>3月名单</title>
    <link href="https://cdn.bootcss.com/MaterialDesign-Webfont/5.0.45/css/materialdesignicons.css" rel="stylesheet">
    <link href="https://cdn.bootcss.com/vuetify/2.2.17/vuetify.min.css" rel="stylesheet">
    <style>
        [v-cloak] {
            display: none;
        }

        .v-speed-dial {
            position: fixed;
        }

        .v-speed-dial__list {
            align-items: flex-end;
        }

        .v-data-table {
            margin-top: 10px;
        }
    </style>
</head>

<body>
    <div id="app" v-cloak>
        <v-app>
            <v-content>
                <v-app-bar dark>
                    <v-container>
                        <v-toolbar-title>3月名单</v-toolbar-title>
                    </v-container>
                </v-app-bar>
                <v-container>
                    <v-textarea dense auto-grow full-width :loading="!loaded" :disabled="!loaded" v-model="sql">
                    </v-textarea>
                    <v-row dense>
                        <v-col cols="12" sm="9">
                            <v-btn @click="query" :disabled="!loaded" block large>查询</v-btn>
                        </v-col>
                        <v-col cols="12" sm="3">
                            <v-btn @click="clearSql" :disabled="!loaded" block large>清除</v-btn>
                        </v-col>
                    </v-row>
                    <v-simple-table v-for="table in result">
                        <template v-slot:default>
                            <thead>
                                <tr>
                                    <th v-for="item in table.columns">{{ item }}</th>
                                </tr>
                            </thead>
                            <tbody>
                                <tr v-for="row in table.values">
                                    <td v-for="item in row">{{ item }}</td>
                                </tr>
                            </tbody>
                        </template>
                    </v-simple-table>
                </v-container>
                <v-speed-dial v-model="fab" bottom right>
                    <template v-slot:activator>
                        <v-btn v-model="fab" dark fab>
                            <v-icon v-if="fab">mdi-close</v-icon>
                            <v-icon v-else>mdi-menu</v-icon>
                        </v-btn>
                    </template>
                    <v-btn v-for='item in sql_template' @click="loadTemplate(item.name)">{{ item.alias }}</v-btn>
                </v-speed-dial>
                <v-snackbar v-model="snackbar" :timeout="0" bottom middle color="red">
                    {{ error_msg }}
                    <v-btn text @click="toggleSnackbar(false)">
                        <v-icon>mdi-close</v-icon>
                    </v-btn>
                </v-snackbar>
            </v-content>
        </v-app>
    </div>
    <script src="https://cdn.bootcss.com/axios/0.19.2/axios.min.js"></script>
    <script src="https://cdn.bootcss.com/sql.js/1.2.1/dist/sql-wasm.js"></script>
    <script src="https://cdn.bootcss.com/vue/2.6.11/vue.min.js"></script>
    <script src="https://cdn.bootcss.com/vuetify/2.2.17/vuetify.min.js"></script>
    <script>
        var App = {
            vuetify: new Vuetify({
                theme: {
                    dark: true,
                },
            }),
            data: {
                db: null,
                sql: 'SELECT name AS "表名", sql AS "创建命令"\nFROM sqlite_master WHERE type = "table";\nSELECT class_name AS "班级名称" FROM class;',
                config: {
                    locateFile: filename => `//cdn.bootcss.com/sql.js/1.2.1/dist/${filename}`
                },
                db_file: 'ynsdfz_202003.db',
                result: [{ columns: [], values: [[]] }],
                loaded: false,
                fab: false,
                sql_template: [],
                error_msg: '',
                snackbar: false
            },
            methods: {
                query: async function () {
                    this.loaded = false;
                    if (this.db) {
                        await new Promise(t => setTimeout(t, 512 + Math.floor(Math.random() * 1000)));
                        try {
                            var contents = await this.db.exec(this.sql);
                            if (contents.length != 0) {
                                this.result = contents;
                            } else {
                                this.result = [{ columns: [], values: [[]] }];
                            }
                        } catch (e) {
                            console.error(e);
                            this.error_msg = e;
                            this.snackbar = true;
                            this.result = [{ columns: [], values: [[]] }];
                        }
                    }
                    this.loaded = true;
                },
                init: async function () {
                    let SQL = await initSqlJs(this.config);
                    let data = await axios(this.db_file, {
                        responseType: 'arraybuffer'
                    });
                    let Uints = new Uint8Array(data.data);
                    return new SQL.Database(Uints);
                },
                loadTemplate: function (template) {
                    for (let i = 0; i < this.sql_template.length; i++) {
                        if (this.sql_template[i].name == template) {
                            this.sql = this.sql_template[i].content || this.sql;
                        }
                    }
                },
                clearSql: function () {
                    this.sql = '';
                },
                toggleSnackbar: function (target) {
                    this.snackbar = target || !this.snackbar;
                }
            },
            created: async function () {
                this.db = await this.init();
                this.query();
                axios.get('template.json').then(data => {
                    this.sql_template = data.data;
                });
            }
        }
        var vm = new Vue(App);
        vm.$mount('#app');
    </script>
</body>

</html>